import { ICallback } from './base/i.callback';
import { AttachementManager } from './attachment/attachement.manager';
export declare function Dao(Class: any, name?: string): <T extends new (...arg: any[]) => {}>(constructor: T) => {
    new (...args: any[]): {
        tableName: string;
        database: any;
        query: any;
        sync: any;
        replication: any;
        whereRes: any;
        attchementManager: AttachementManager;
        isFromBase: boolean;
        get(callback?: ICallback): Promise<any>;
        getDocsWithCallBack(callback: ICallback): Promise<unknown>;
        getDocsInPromise(): Promise<unknown>;
        syncWith(url: any, options?: any): any;
        replicateTo(url: any, options?: any): any;
        replicateFrom(url: any, options?: any): any;
        getAttachementManager(): AttachementManager;
        put(data: any, callback?: any): Promise<any>;
        putBaseMode(data: any, callback?: any): Promise<any>;
        delete(doc: any, callback?: ICallback): Promise<any>;
        update(value: any, callback?: any): Promise<any>;
        set(newObjects: any): Promise<any[]>;
        deleteWhereWithCallBack(field: string | number, value: any, operator?: any, callback?: ICallback): Promise<any[]>;
        where(field: any, value: any, operator?: any): any;
        first(callback?: ICallback): Promise<any>;
        apply(callback?: ICallback): Promise<any>;
        applyWithCallBack(callback: ICallback, isFirst: boolean): Promise<any>;
        orderBy(field: any, order?: any): any;
        select(fields: any): any;
        limit(limit: number): any;
        deleteWhere(field: any, value: any, operator?: any, callback?: ICallback): Promise<any>;
        deleteWhereAndGetResult(field: any, value: any, operator: any): Promise<any[]>;
        buildOrderByClause(field: any, order?: any): any;
        buildWhereClause(field: any, value: any, operator?: any): any;
        orWhere(field: any, value: any, operator?: any): any;
        deleteWithCallBack(doc: any, callback: ICallback): Promise<void>;
    };
} & T;
