import { IDao } from './base/i.dao';
import { ICallback } from './base/i.callback';
export declare class MasterDoa implements IDao {
    tableName: string;
    database: any;
    query: any;
    sync: any;
    whereRes: any;
    constructor(database: any);
    get(callback?: ICallback): Promise<any>;
    getDocsWithCallBack(callback: ICallback): Promise<unknown>;
    getDocsInPromise(): Promise<unknown>;
    put(data: any, callback?: any): Promise<any>;
    delete(doc: any, callback?: ICallback): Promise<any>;
    updateWhere(field: any, value: any, operator?: any, callback?: any): Promise<this>;
    set(newObjects: any): Promise<any[]>;
    updateWithCallBack(field: string | number, value: any, operator?: any, callback?: ICallback): Promise<any[]>;
    deleteWhereWithCallBack(field: string | number, value: any, operator?: any, callback?: ICallback): Promise<any[]>;
    updateAndGetResult(toUpdate: any, newData: any, field: any, value: any): Promise<any[]>;
    where(field: any, value: any, operator?: any): this;
    first(callback?: ICallback): Promise<any>;
    apply(callback?: ICallback): Promise<any>;
    applyWithCallBack(callback: ICallback, isFirst: boolean): Promise<any>;
    orderBy(field: any, order?: any): any;
    select(fields: any): any;
    limit(limit: number): any;
    deleteWhere(field: any, value: any, operator?: any, callback?: ICallback): Promise<any>;
    deleteWhereAndGetResult(field: any, value: any, operator: any): Promise<any[]>;
    update(value: any, callback?: any): Promise<any>;
    buildOrderByClause(field: any, order?: any): any;
    buildWhereClause(field: any, value: any, operator?: any): any;
    orWhere(field: any, value: any, operator?: any): any;
    deleteWithCallBack(doc: any, callback: ICallback): Promise<void>;
}
